
#ifdef WIN32
 #include <stdio.h>
 #include <winsock2.h>
 #define close(x) closesocket(x)
 typedef int size_type;
#else
 #include <stdio.h>
 #include <unistd.h>
 #include <stdlib.h>
 #include <string.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 typedef unsigned int size_type;
#endif

const int BLOCK = 128;

int sock=0,sock_r=0;
FILE *file = 0;

void cleanup() {
  // CLOSE FILE & SOCKET
  if (file) fclose(file); file = 0;
  if (sock) close(sock); sock = 0;
  if (sock_r) close(sock_r); sock_r = 0;

  // CLOSE LIBRARY
#ifdef WIN32
  WSACleanup();
#endif
}

bool init() {
  // INITIALIZE LIBRARY
#ifdef WIN32
  WSADATA wsaData;
  if (WSAStartup(2, &wsaData ) != 0) {
    cleanup();
    return false;
  }
#endif
  return true;
}

int recvfile(int port, const char *filename) {

  // OPEN SOCKET
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (!sock) return 3;

  // PREPARE ADDRESS
  sockaddr_in address;
  memset(&address, 0, sizeof(address));
  address.sin_family = AF_INET;
  address.sin_port = htons(port);
  address.sin_addr.s_addr = INADDR_ANY;

  // BIND SOCKET WITH ADDRESS
  if (bind(sock, (sockaddr*)&address, sizeof(address))) return 4;

  // LISTEN FOR CONNECTION
  if (listen(sock, 1)) return 5;

  // ACCEPT A CONNECTION
  sockaddr_in address_r;
  size_type address_r_size;
  sock_r = accept(sock, (sockaddr*)&address_r, &address_r_size);
  if (sock_r==-1) return 6;
  
  // OPEN FILE
  file = fopen(filename,"wb");
  if (!file) return 7;

  // RECEIVE DATA
  char buffer[BLOCK]; int length, total = 0;
  while ((length = recv(sock_r,buffer,BLOCK,0))>0) {
    int written = fwrite(buffer,1,length,file);
    if (written!=length) return 8;
    printf("%9d received\r",total+=written);
  }
  if (length<0) return 9;

  return 0;
}

int main(int argc, char *argv[]) {
  int ret = 0;
  if (init()) {
    ret = (argc>=2) ? recvfile(atoi(argv[1]),argv[2]) : 1;
    cleanup();
  }
  else {
    ret = 2;
  }
  printf("\n");
  if (ret) printf("recv returned %d\n",ret);
  return ret;
};
