
#ifdef WIN32
 #include <stdio.h>
 #include <winsock2.h>
 #define close(x) closesocket(x)
#else
 #include <stdio.h>
 #include <unistd.h>
 #include <stdlib.h>
 #include <string.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
#endif

const int BLOCK = 128;

int sock=0;
FILE *file = 0;

void cleanup() {
  // CLOSE FILE & SOCKET
  if (file) fclose(file); file = 0;
  if (sock) close(sock); sock = 0;

  // CLOSE LIBRARY
#ifdef WIN32
  WSACleanup();
#endif
}

bool init() {
  // INITIALIZE LIBRARY
#ifdef WIN32
  WSADATA wsaData;
  if (WSAStartup(2, &wsaData ) != 0) {
    cleanup();
    return false;
  }
#endif
  return true;
}

int sendfile(const char *host, int port, const char *filename) {

  // OPEN SOCKET
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (!sock) return 2;

  // PREPARE ADDRESS
  sockaddr_in address;
  memset(&address, 0, sizeof(address));
  address.sin_family = AF_INET;
  address.sin_port = htons(port);
  address.sin_addr.s_addr = inet_addr(host);

  // CONNECT
  if (connect(sock, (sockaddr *) &address, sizeof(address))) return 4;

  // OPEN FILE
  file = fopen(filename,"rb");
  if (!file) return 5;

  // SEND DATA
  char buffer[BLOCK]; int length, total = 0;
  while (length = fread(buffer,1,BLOCK,file)) {
    while (length > 0) {
      int sent = send(sock, buffer, length, 0);
      if (sent<=0) return 5;
      length -= sent;
      printf("%8d sent\r",total+=sent);
    }
  }

  return 0;
}

int main(int argc, char *argv[]) {
  int ret = 0;
  if (init()) {
    ret = (argc>=3) ? sendfile(argv[1],atoi(argv[2]),argv[3]) : 1;
    cleanup();
  }
  else {
    ret = 2;
  }
  printf("\n");
  if (ret) printf("\nsend returned %d\n",ret);
  return ret;
};
