
import java.rmi.*; 
import java.io.*; 

public class Client {
  static class Town implements Serializable {
    String name;
    String country;
    Town(String name, String country) {
      this.name = name;
      this.country = country;
    }
    public String toString() {
      return name+" in "+country;
    }
  }
  public static void main(String[] args) { 
    try {
      Inter obj = (Inter)Naming.lookup("rmi://127.0.0.1/Server");
      Town town;
      
      System.out.println("Testing persistency ..");
      town = (Town)obj.get("Prague");
      if (town==null)
        System.out.println("Prague is not there");
      else
        System.out.println("Prague is there");
      
      System.out.println("Adding values ..");

      town = new Town("Prague","Czech Republic");
      obj.set(town.name,town);
      town = new Town("Ulanbatar","Mongolia");
      obj.set(town.name,town);
      town = new Town("Sofia","Bulgaria");
      obj.set(town.name,town);

      System.out.println("Retrieving values ..");

      town = (Town)obj.get("Ulanbatar");
      System.out.println("Got "+town);
      town = (Town)obj.get("Prague");
      System.out.println("Got "+town);

      System.out.println("Removing values ..");

      obj.del("Ulanbatar");
      town = (Town)obj.get("Ulanbatar");
      if (town==null)
        System.out.println("OK - doesn't exist");
      else
        System.out.println("WRONG - exists");
    }
    catch (Exception e) {
      System.out.println(e); 
      e.printStackTrace(); 
    }
  }
}
